

ifeq ($(DEBUG),yes)
	CFLAGS += -g3 -O0 
endif

ifeq ($(DEBUG),no)
	CFLAGS += -g -O3 
endif

ifeq ($(BENCH),yes)
	CFLAGS += -fno-inline  
endif
 
ifeq ($(SIFIVE_GCC_PACK),yes)
	RISCV_CLIB=$(RISCV_PATH)/$(RISCV_NAME)/lib/$(MARCH)/$(MABI)/
else
	RISCV_CLIB=$(RISCV_PATH)/$(RISCV_NAME)/lib/
endif





RISCV_OBJCOPY = $(RISCV_PATH)/bin/$(RISCV_NAME)-objcopy
RISCV_OBJDUMP = $(RISCV_PATH)/bin/$(RISCV_NAME)-objdump
RISCV_CC=$(RISCV_PATH)/bin/$(RISCV_NAME)-gcc
CC=$(RISCV_PATH)/bin/$(RISCV_NAME)-gcc

##CFLAGS +=  -MD -fstrict-volatile-bitfields  -ffunction-sections
##LDFLAGS += -e_start  -nostartfiles -T $(LDSCRIPT) -Wl,-Map,$(OBJDIR)/$(PROJ_NAME).map -Wl,--print-memory-usage
##LDFLAGS += $(RISCV_CLIB)/libc.a $(RISCV_CLIB)/libnosys.a

CFLAGS +=  -fstrict-volatile-bitfields  -ffunction-sections -fdata-sections
LDFLAGS +=  -lgcc -mcmodel=medany -nostartfiles -ffreestanding -Wl,-Bstatic,-T,$(LDSCRIPT),-Map,$(OBJDIR)/$(PROJ_NAME).map,--print-memory-usage -Wl,--gc-sections



OBJDIR ?= build
OBJS := $(SRCS)
OBJS := $(OBJS:.c=.o)
OBJS := $(OBJS:.cpp=.o)
OBJS := $(OBJS:.S=.o)
OBJS := $(OBJS:..=miaou)
OBJS := $(addprefix $(OBJDIR)/,$(OBJS))


#all: $(OBJDIR)/$(PROJ_NAME).elf $(OBJDIR)/$(PROJ_NAME).hex $(OBJDIR)/$(PROJ_NAME).asm $(OBJDIR)/$(PROJ_NAME).v

$(OBJDIR)/%.elf: $(OBJS) | $(OBJDIR)
	$(RISCV_CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) $(LIBS)

%.hex: %.elf
	$(RISCV_OBJCOPY) -O ihex $^ $@

%.bin: %.elf
	$(RISCV_OBJCOPY) -O binary $^ $@
	
%.v: %.elf
	$(RISCV_OBJCOPY) -O verilog $^ $@
	
	
	
%.asm: %.elf
	$(RISCV_OBJDUMP) -S -d $^ > $@

#$(OBJDIR)/%.o: %.c
#	mkdir -p $(dir $@)
#	$(RISCV_CC) -c $(CFLAGS)  $(INC) -o $@ $^
#	
#$(OBJDIR)/%.o: %.cpp
#	mkdir -p $(dir $@)
#	$(RISCV_CC) -c $(CFLAGS)  $(INC) -o $@ $^	
#
#$(OBJDIR)/%.o: %.S
#	mkdir -p $(dir $@)
#	$(RISCV_CC) -c $(CFLAGS) -o $@ $^ -D__ASSEMBLY__=1
#
#$(OBJDIR):
#	mkdir -p $@
#
#clean:
#	rm -f $(OBJDIR)/$(PROJ_NAME).elf
#	rm -f $(OBJDIR)/$(PROJ_NAME).hex
#	rm -f $(OBJDIR)/$(PROJ_NAME).map
#	rm -f $(OBJDIR)/$(PROJ_NAME).v
#	rm -f $(OBJDIR)/$(PROJ_NAME).asm
#	find $(OBJDIR) -type f -name '*.o' -print0 | xargs -0 -r rm
#
#.SECONDARY: $(OBJS)


			
